# AIListWindow Struct Reference

Window that let you choose an available AI. More...

Inheritance diagram for AIListWindow:

## Public Member Functions
| AIListWindow (const WindowDesc *desc, CompanyID slot)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | ChangeAI ()
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnDoubleClick (Point pt, int widget)
| A double click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
## Data Fields
const AIInfoList * | ai_info_list
int | selected
CompanyID | slot
int | line_height

## Detailed Description

Window that let you choose an available AI.

Definition at line 46 of file ai_gui.cpp.

## Member Function Documentation

virtual void AIListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 75 of file ai_gui.cpp.

References AIL_WIDGET_LIST, FONT_HEIGHT_NORMAL, GB(), Dimension::height, MAT_ROW_BITS, MAT_ROW_START, WD_MATRIX_BOTTOM, WD_MATRIX_TOP, and Dimension::width.

virtual void AIListWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 86 of file ai_gui.cpp.

References Window::DrawWidgets().

virtual void AIListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 91 of file ai_gui.cpp.

References AIL_WIDGET_INFO_BG, AIL_WIDGET_LIST, Rect::bottom, DrawString(), DrawStringMultiLine(), FONT_HEIGHT_NORMAL, Scrollbar::IsVisible(), Rect::left, Rect::right, SetDParam(), SetDParamStr(), Rect::top, Window::vscroll, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, WD_MATRIX_LEFT, WD_MATRIX_RIGHT, WD_MATRIX_TOP, and WD_PAR_VSEP_NORMAL.

virtual void AIListWindow::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 151 of file ai_gui.cpp.

References AIL_WIDGET_ACCEPT, AIL_WIDGET_CANCEL, AIL_WIDGET_LIST, Scrollbar::GetPosition(), Window::SetDirty(), Window::vscroll, and Point::y.

virtual void AIListWindow::OnDoubleClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A double click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 175 of file ai_gui.cpp.

References AIL_WIDGET_LIST, Scrollbar::GetPosition(), Window::vscroll, and Point::y.

virtual void AIListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 190 of file ai_gui.cpp.

References AIL_WIDGET_LIST, NWidgetBase::current_y, Scrollbar::GetCapacity(), MAT_COL_START, MAT_ROW_START, Scrollbar::SetCapacity(), Window::vscroll, and NWidgetCore::widget_data.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp